Index: trunk/source/Lib/TLibEncoder/TEncSbac.h
===================================================================
--- trunk/source/Lib/TLibEncoder/TEncSbac.h	(revision 1085)
+++ trunk/source/Lib/TLibEncoder/TEncSbac.h	(revision 1124)
@@ -94,8 +94,12 @@
 
   Void  codeVPS                 ( TComVPS* pcVPS );
+#if HHI_TOOL_PARAMETERS_I2_J0107
+  Void  codeSPS                 ( TComSPS* pcSPS     );
+#else
 #if !H_3D
   Void  codeSPS                 ( TComSPS* pcSPS     );
 #else
   Void  codeSPS                 ( TComSPS* pcSPS, Int viewIndex, Bool depthFlag );
+#endif
 #endif
   Void  codePPS                 ( TComPPS* pcPPS     );
Index: trunk/source/Lib/TLibEncoder/TEncSearch.cpp
===================================================================
--- trunk/source/Lib/TLibEncoder/TEncSearch.cpp	(revision 1085)
+++ trunk/source/Lib/TLibEncoder/TEncSearch.cpp	(revision 1124)
@@ -2881,7 +2881,15 @@
   Int index=0;
   Pel testDepth;
+#if SINGLE_DEPTH_SIMP_J0115
+  Pel DepthNeighbours[2];
+#else
   Pel DepthNeighbours[5];
+#endif
   //construction of depth candidates
+#if SINGLE_DEPTH_SIMP_J0115
+  for( Int i = 0; (i < 2)  && (index<SINGLE_DEPTH_MODE_CAND_LIST_SIZE) ; i++ )
+#else
   for( Int i = 0; (i < 5)  && (index<SINGLE_DEPTH_MODE_CAND_LIST_SIZE) ; i++ )
+#endif
   {
     if(!pcCU->getNeighDepth (0, 0, &testDepth, i))
@@ -2891,4 +2899,5 @@
     DepthNeighbours[index]=testDepth;
     index++;
+#if !SINGLE_DEPTH_SIMP_J0115
     for(Int j=0;j<index-1;j++)
     {
@@ -2899,4 +2908,5 @@
       }
     }
+#endif
   }
 
@@ -3117,10 +3127,14 @@
     }
 #endif
-
+    
 #if H_3D_DIM
     //===== determine set of depth intra modes to be tested =====
     if( m_pcEncCfg->getIsDepth() && uiWidth >= DIM_MIN_SIZE && uiWidth <= DIM_MAX_SIZE && uiWidth == uiHeight )
     {
+#if HHI_TOOL_PARAMETERS_I2_J0107
+      if( bOnlyIVP && pcCU->getSlice()->getIntraContourFlag() )
+#else
       if( bOnlyIVP && m_pcEncCfg->getUseIVP() )
+#endif
       {
         TComWedgelet* dmm4Segmentation = new TComWedgelet( uiWidth, uiHeight );
@@ -3144,5 +3158,9 @@
 
 #if H_3D_DIM_DMM
+#if HHI_TOOL_PARAMETERS_I2_J0107
+      if( ( ( m_pcEncCfg->getUseDMM() &&  pcCU->getSlice()->getIntraSdcWedgeFlag() )  || pcCU->getSlice()->getIntraContourFlag() )
+#else
       if( ( m_pcEncCfg->getUseDMM() || m_pcEncCfg->getUseIVP() )
+#endif
 #if H_3D_FAST_DEPTH_INTRA
          && (uiRdModeList[0] != PLANAR_IDX || varCU >= varThreshold)
@@ -3151,15 +3169,27 @@
       {
         UInt uiStart, uiEnd;
+#if HHI_TOOL_PARAMETERS_I2_J0107
+        if( ( m_pcEncCfg->getUseDMM() &&  pcCU->getSlice()->getIntraSdcWedgeFlag() ) &&  pcCU->getSlice()->getIntraContourFlag() )
+#else
         if( m_pcEncCfg->getUseDMM() &&  m_pcEncCfg->getUseIVP() )
+#endif
         {
           uiStart = 0;
           uiEnd   = 2;
         }
+#if HHI_TOOL_PARAMETERS_I2_J0107
+        else if( ( m_pcEncCfg->getUseDMM() &&  pcCU->getSlice()->getIntraSdcWedgeFlag() ) )
+#else
         else if( m_pcEncCfg->getUseDMM() )
+#endif
         {
           uiStart = 0;
           uiEnd   = 1;
         }
+#if HHI_TOOL_PARAMETERS_I2_J0107
+        else if( pcCU->getSlice()->getIntraContourFlag() )
+#else
         else if( m_pcEncCfg->getUseIVP() )
+#endif
         {
           uiStart = 1;
@@ -3299,5 +3329,9 @@
 #if H_3D_DIM_SDC
 #if H_3D_FAST_INTRA_SDC
+#if HHI_TOOL_PARAMETERS_I2_J0107
+      Bool bTestSDC = ( ( m_pcEncCfg->getUseSDC() &&  pcCU->getSlice()->getIntraSdcWedgeFlag() ) && pcCU->getSDCAvailable(uiPartOffset) && uiMode >= numModesForFullRD);
+#else
       Bool bTestSDC = ( m_pcEncCfg->getUseSDC() && pcCU->getSDCAvailable(uiPartOffset) && uiMode >= numModesForFullRD);
+#endif
 #else
       Bool bTestSDC = ( m_pcEncCfg->getUseSDC() && pcCU->getSDCAvailable(uiPartOffset) );
@@ -4143,5 +4177,5 @@
       }
 #endif
-
+#if !LGE_DDD_REMOVAL_J0042_J0030
 #if H_3D_DDD
       if( uiMergeCand == pcCU->getUseDDDCandIdx() )
@@ -4154,4 +4188,5 @@
         pcCU->setUseDDD( false, uiAbsPartIdx, iPUIdx, pcCU->getDepth( uiAbsPartIdx ) );
       }
+#endif
 #endif
 
@@ -4841,4 +4876,5 @@
         pcCU->setVSPFlagSubParts( vspFlag[uiMRGIndex], uiPartAddr, iPartIdx, pcCU->getDepth( uiPartAddr ) );
 #endif
+#if !LGE_DDD_REMOVAL_J0042_J0030
 #if H_3D_DDD
         if( uiMRGIndex == pcCU->getUseDDDCandIdx() )
@@ -4853,4 +4889,5 @@
             pcCU->setUseDDD( false, uiPartAddr, iPartIdx, pcCU->getDepth( uiPartAddr ) );
         }
+#endif
 #endif
 #if H_3D_SPIVMP
@@ -4930,6 +4967,8 @@
         pcCU->setSPIVMPFlagSubParts(0, uiPartAddr, iPartIdx, pcCU->getDepth( uiPartAddr ) ); 
 #endif
+#if !LGE_DDD_REMOVAL_J0042_J0030
 #if H_3D_DDD
         pcCU->setUseDDD( false, uiPartAddr, iPartIdx, pcCU->getDepth( uiPartAddr ) );
+#endif
 #endif
         // set ME result
@@ -5314,4 +5353,7 @@
 #endif
 #if H_3D_INTER_SDC
+#if HHI_TOOL_PARAMETERS_I2_J0107  
+   pcPatternKey->setSDCMRSADFlag( pcCU->getSlice()->getInterSdcFlag() );
+#else
   if ( pcCU->getSlice()->getIsDepth() && pcCU->getSlice()->getVPS()->getInterSDCFlag( pcCU->getSlice()->getLayerIdInVps() ) )
   {
@@ -5322,4 +5364,5 @@
     pcPatternKey->setSDCMRSADFlag( false );
   }
+#endif
 #endif
 
Index: trunk/source/Lib/TLibEncoder/TEncSlice.cpp
===================================================================
--- trunk/source/Lib/TLibEncoder/TEncSlice.cpp	(revision 1085)
+++ trunk/source/Lib/TLibEncoder/TEncSlice.cpp	(revision 1124)
@@ -215,4 +215,9 @@
   rpcSlice->setPicOutputFlag( true );
   rpcSlice->setPOC( pocCurr );
+#if HHI_TOOL_PARAMETERS_I2_J0107
+#if H_3D
+  rpcSlice->init3dToolParameters(); 
+#endif
+#endif
 #if H_3D_IC
   rpcSlice->setApplyIC( false );
@@ -608,4 +613,11 @@
   rpcSlice->setSliceSegmentArgument ( m_pcCfg->getSliceSegmentArgument() );
 #if H_3D_IV_MERGE
+#if HHI_TOOL_PARAMETERS_I2_J0107
+#if ALGIN_J0107_J0059
+  rpcSlice->setMaxNumMergeCand      ( m_pcCfg->getMaxNumMergeCand()   + ( ( rpcSlice->getMpiFlag( ) || rpcSlice->getIvMvPredFlag( ) || rpcSlice->getViewSynthesisPredFlag( )   ) ? 1 : 0 ));
+#else
+  rpcSlice->setMaxNumMergeCand      ( m_pcCfg->getMaxNumMergeCand()   + ( ( rpcSlice->getMpiFlag( ) || rpcSlice->getIvMvPredFlag( ) ) ? 1 : 0 ));
+#endif
+#else
   if(rpcSlice->getIsDepth())
   {
@@ -614,6 +626,11 @@
   else
   {
+#if MTK_MRG_LIST_SIZE_CLEANUP_J0059
+    rpcSlice->setMaxNumMergeCand      ( m_pcCfg->getMaxNumMergeCand()   + ( rpcSlice->getVPS()->getIvMvPredFlag( rpcSlice->getLayerIdInVps() )  || rpcSlice->getVPS()->getViewSynthesisPredFlag( rpcSlice->getLayerIdInVps() ) ? 1 : 0 ) );
+#else
     rpcSlice->setMaxNumMergeCand      ( m_pcCfg->getMaxNumMergeCand()   + ( rpcSlice->getVPS()->getIvMvPredFlag( rpcSlice->getLayerIdInVps() ) ? 1 : 0 ) );
-  }
+#endif
+  }
+#endif
 #else
   rpcSlice->setMaxNumMergeCand        ( m_pcCfg->getMaxNumMergeCand()        );
@@ -1011,4 +1028,37 @@
     }
   }
+#if LGE_DEFAULT_DV_J0046 && !SEC_ARP_VIEW_REF_CHECK_J0037 && !SEC_DBBP_VIEW_REF_CHECK_J0037
+  pcSlice->setDefaultRefViewIdx( -1 );
+  pcSlice->setDefaultRefViewIdxAvailableFlag( false ); 
+
+  Int valid = 0;
+  Int viewIndex = 0;
+  for( UInt uiBId = 0; uiBId < pcSlice->getViewIndex() && valid==0; uiBId++ )
+  {
+      UInt        uiBaseId    = uiBId;
+      TComPic*    pcBasePic   = pcSlice->getIvPic( false, uiBaseId );
+      for( Int iRefListId = 0; ( iRefListId < (pcSlice->isInterB()? 2:1) ) && !pcSlice->isIntra() && valid==0; iRefListId++ )
+      {
+          RefPicList  eRefPicListTest = RefPicList( iRefListId );
+          Int         iNumRefPics = pcSlice->getNumRefIdx( eRefPicListTest ) ;
+          for( Int iRefIndex = 0; iRefIndex < iNumRefPics; iRefIndex++ )
+          { 
+              if(pcBasePic->getPOC() == pcSlice->getRefPic( eRefPicListTest, iRefIndex )->getPOC() 
+                  && pcBasePic->getViewIndex() == pcSlice->getRefPic( eRefPicListTest, iRefIndex )->getViewIndex())
+              {
+                  valid=1;
+                  viewIndex = uiBaseId;
+                  break;
+              }
+          }
+      }
+  }
+  if( valid )
+  {
+      pcSlice->setDefaultRefViewIdx( viewIndex );
+      pcSlice->setDefaultRefViewIdxAvailableFlag( true );   
+  }
+#endif
+
   // for every CU in slice
 #if H_3D
@@ -1169,5 +1219,4 @@
 #endif
       }
-
       // run CU encoder
       m_pcCuEncoder->compressCU( pcCU );
Index: trunk/source/Lib/TLibEncoder/TEncSlice.h
===================================================================
--- trunk/source/Lib/TLibEncoder/TEncSlice.h	(revision 1085)
+++ trunk/source/Lib/TLibEncoder/TEncSlice.h	(revision 1124)
@@ -107,8 +107,10 @@
   UInt                    m_uiSliceIdx;
   std::vector<TEncSbac*> CTXMem;
+#if !LGE_DDD_REMOVAL_J0042_J0030
 #if H_3D_DDD
   Int          m_iDDDScale;
   Int          m_iDDDOffset;
   UInt         m_uiDDDPrecision;
+#endif
 #endif
 public:
@@ -145,7 +147,8 @@
   Void      initCtxMem( UInt i );
   Void      setCtxMem( TEncSbac* sb, Int b )   { CTXMem[b] = sb; }
-
+#if !LGE_DDD_REMOVAL_J0042_J0030
 #if H_3D_DDD
   Void setDDDPar( Int iScale, Int iOffset, UInt uiPrecision ){ m_iDDDScale = iScale; m_iDDDOffset = iOffset; m_uiDDDPrecision = uiPrecision; }
+#endif
 #endif
 
Index: trunk/source/Lib/TLibEncoder/TEncTop.cpp
===================================================================
--- trunk/source/Lib/TLibEncoder/TEncTop.cpp	(revision 1085)
+++ trunk/source/Lib/TLibEncoder/TEncTop.cpp	(revision 1124)
@@ -534,5 +534,5 @@
 Void TEncTop::encode(Bool flush, TComPicYuv* pcPicYuvOrg, TComList<TComPicYuv*>& rcListPicYuvRecOut, std::list<AccessUnit>& accessUnitsOut, Int& iNumEncoded, bool isTff, Int gopId )
 {
-  assert( 0 ); // Field coding and multiview need to be furhter harmonized. 
+  assert( 0 ); // Field coding and multiview need to be further harmonized. 
 }
 #else
@@ -896,5 +896,14 @@
 #if H_MV
   m_cPPS.setLayerId( getLayerId() );
+#if HHI_DEPENDENCY_SIGNALLING_I1_J0107
+#if H_3D
+  // Check if this condition is still correct
+  if( getVPS()->getNumRefListLayers( getLayerId() ) > 0 )
+#else
   if( getVPS()->getNumDirectRefLayers( getLayerId() ) > 0 )
+#endif
+#else
+  if( getVPS()->getNumDirectRefLayers( getLayerId() ) > 0 )
+#endif
   {
     m_cPPS.setListsModificationPresentFlag( true );
Index: trunk/source/Lib/TLibEncoder/TEncTop.h
===================================================================
--- trunk/source/Lib/TLibEncoder/TEncTop.h	(revision 1085)
+++ trunk/source/Lib/TLibEncoder/TEncTop.h	(revision 1124)
@@ -270,4 +270,9 @@
   Void                    setIvPicLists         ( TComPicLists* picLists) { m_ivPicLists = picLists; }
 #endif
+#if HHI_TOOL_PARAMETERS_I2_J0107
+#if H_3D
+  Void                    setSps3dExtension     ( TComSps3dExtension sps3dExtension ) { m_cSPS.setSps3dExtension( sps3dExtension );  };
+#endif
+#endif
 #if H_3D_IC
   Void                    setICEnableCandidate         ( Int* ICEnableCandidate) { m_aICEnableCandidate = ICEnableCandidate; }
Index: trunk/source/Lib/TLibExtractor/TExtrTop.cpp
===================================================================
--- trunk/source/Lib/TLibExtractor/TExtrTop.cpp	(revision 1085)
+++ trunk/source/Lib/TLibExtractor/TExtrTop.cpp	(revision 1124)
@@ -73,6 +73,11 @@
      TComSPS     cSPS;
 #if H_3D
-     Int layerIdInVPS = m_cVPS.getLayerIdInVps( uiLayerId ); 
+
+#if HHI_TOOL_PARAMETERS_I2_J0107
+     m_cEntropyDecoder   .decodeSPS( &cSPS );
+#else
+      Int layerIdInVPS = m_cVPS.getLayerIdInVps( uiLayerId ); 
      m_cEntropyDecoder   .decodeSPS( &cSPS, m_cVPS.getViewIndex( layerIdInVPS ), ( m_cVPS.getDepthId( layerIdInVPS ) == 1 ) );
+#endif
 #else
      m_cEntropyDecoder   .decodeSPS( &cSPS );
